/*
 *      newexe.h
 *
 *      Copyright (c) 1994 by Borland International
 *      All Rights Reserved.
 *
 */

/* This include file describes the NewExe header */

typedef struct
{
   bits16 ne_magic;	/* Magic value 'NE' */
   bits8  ne_ver;	/* version number */
   bits8  ne_rev;	/* revision number */
   bits16 ne_enttab;	/* offset to entry table */
   bits16 ne_cbenttab;	/* number of bytes in entry table */
   bits32 ne_crc;	/* CRC of file */
   bits16 ne_flags; /* flag word */
   bits16 ne_autodata;	/* segment number of auto data segment */
   bits16 ne_heap;	/* initial size of local heap */
   bits16 ne_stack;	/* initial size of stack */
   bits32 ne_csip;	/* CS:IP start address */
   bits32 ne_sssp;	/* SS:SP initial stack pointer.  0 if
				 * stack size word non-zero */
   bits16 ne_cseg;	/* # of segment in segment table */
   bits16 ne_cmod;	/* # of entries in module reference table */
   bits16 ne_cbnrestab;	/* # of bytes in non-resident name table */
   bits16 ne_segtab;	/* relative offset to segment table */
   bits16 ne_rsrctab;	/* relative offset to resource table */
   bits16 ne_restab;    /* relative offset to resident name table */
   bits16 ne_modtab;	/* relative offset to module reference table */
   bits16 ne_imptab;	/* relative offset to imported name table */
   bits32 ne_nrestab;	/* file offset to non-resident name table */
   bits16 ne_cmovent;   /* Count of movable entries */
   bits16 ne_align;	/* Alignment shift count for segment data */
   bits16 ne_cres;	/* Count of resource segments */
   bits8 ne_exetyp;	/* Target operating system */
   bits8 ne_flagsother;	/* Other .EXE flags */
   union
   {
      bits16 ne_pretthunks; /* offset to return thunks      */
      bits16 ne_gang_start; /* start of gangload area       */
   } x;
   union
   {
      bits16 ne_psegrefbytes; /* offset to segment ref. bytes */
      bits16 ne_gang_length;  /* length of gangload area      */
   } y;
   bits16 ne_swaparea;	/* minimum code swap area size  */
   bits16 ne_expver;       /* expected windows version num */
} TNewExeHeader;

#define NEMAGIC   0x454E

#define EXPWINVER 0x0300

#define NENOTP		0x8000	/* Not a process (i.e. a library module) */
#define NEPRIVLIB	0x4000	/* A library which lives above the line */
#define NEIERR		0x2000	/* Errors in image */
#define NESELFLOAD	0x0800	/* Self loading .EXE file */
#define NEAPPTYP	0x0700	/* Application type mask */
#define NENOTWINCOMPAT	0x0100	/* Not compatible with P.M. Windowing */
#define NEWINCOMPAT	0x0200	/* Compatible with P.M. Windowing */
#define NEWINAPI	0x0300	/* Uses P.M. Windowing API */
#define NEFLTP		0x0080	/* Floating-point instructions */
#define NEI386		0x0040	/* 386 instructions */
#define NEI286		0x0020	/* 286 instructions */
#define NEI086		0x0010	/* 8086 instructions */
#define NEPROT		0x0008	/* Runs in protected mode only */
#define NEPPLI		0x0004	/* Per-Process Library Initialization */
#define NEINST		0x0002	/* Instance data */
#define NESOLO		0x0001	/* Solo data */

#define NEWINPROT       NEIERR
#define NENONRES        NEFLTP	/* Contains non-resident code segments */
#define NEALLOCHIGH     NEI386	/* Private allocs above the line okay */
#define NEEMSSEPINST    NEI286	/* Want each instance in separate */
#define NELIM32         NEI086	/* Uses LIM 3.2 API (Intel Above board) */

#define NELONGNAMES     1
#define NEINPROT        2	/* WIN30 - 2.x app runs in 3.x prot mode */
#define NEINFONT        4	/* WIN30 - 2.x app gets proportional font */
#define NEGANGLOAD      8	/* WIN30 - Contains gangload area */

// Target operating systems

#define NE_UNKNOWN      0	/* Unknown (any "new-format" OS) */
#define NE_OS2          1	/* Microsoft/IBM OS/2 (default) */
#define NE_WINDOWS      2	/* Microsoft Windows */
#define NE_DOS4         3	/* Microsoft MS-DOS 4.x */
#define NE_DEV386       4	/* Microsoft Windows 386 */

